> ## Documentation Index
> Fetch the complete documentation index at: https://portkey-docs-feat-rerank-documentation.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Pinecone

> Portkey provides a robust and secure gateway to facilitate the integration of Pinecone's reranking models into your applications.

With Portkey, you can take advantage of features like fast AI gateway access, observability, prompt management, and more, all while ensuring the secure management of your API keys through a [virtual key](/product/ai-gateway/virtual-keys) system.

<Note>
  Provider Slug: **pinecone**
</Note>

## Portkey SDK Integration with Pinecone

Portkey provides a consistent API to interact with Pinecone's reranking models. To integrate Pinecone with Portkey:

### 1. Install the Portkey SDK

Add the Portkey SDK to your application to interact with Pinecone's models through Portkey's gateway.

<Tabs>
  <Tab title="NodeJS">
    ```sh theme={"system"}
    npm install --save portkey-ai
    ```
  </Tab>

  <Tab title="Python">
    ```sh theme={"system"}
    pip install portkey-ai
    ```
  </Tab>
</Tabs>

### 2. Initialize Portkey with the Virtual Key

To use Pinecone with Portkey, [get your API key from here](https://app.pinecone.io/), then add it to Portkey to create the virtual key.

### 3. Reranking with Pinecone

Portkey supports Pinecone's reranking models through a unified `/v1/rerank` endpoint.

```sh theme={"system"}
curl https://api.portkey.ai/v1/rerank \
  -H "Content-Type: application/json" \
  -H "x-portkey-api-key: $PORTKEY_API_KEY" \
  -d '{
    "model": "@pinecone-dev/bge-reranker-v2-m3",
    "query": "What is the capital of the United States?",
    "documents": [
      "Carson City is the capital city of the American state of Nevada.",
      "The Commonwealth of the Northern Mariana Islands is a group of islands in the Pacific Ocean. Its capital is Saipan.",
      "Washington, D.C. (also known as simply Washington or D.C., and officially as the District of Columbia) is the capital of the United States. It is a federal district.",
      "Capital punishment (the death penalty) has existed in the United States since beforethe United States was a country. As of 2017, capital punishment is legal in 30 of the 50 states."
    ],
    "top_n": 3
  }'
```

### Pinecone-Specific Parameters

| Parameter     | Type   | Description                                          |
| ------------- | ------ | ---------------------------------------------------- |
| `rank_fields` | array  | List of fields to rank by when documents are objects |
| `parameters`  | object | Additional model-specific parameters                 |

## Supported Models

Portkey works with all the reranking models offered by Pinecone. You can browse the full list of Pinecone models [here](https://docs.pinecone.io/guides/inference/rerank).

| Model                | Description                       |
| -------------------- | --------------------------------- |
| `bge-reranker-v2-m3` | BGE Reranker v2 M3 model          |
| `pinecone-rerank-v0` | Pinecone's native reranking model |

## Next Steps

The complete list of features supported in the SDK is available on the link below.

<Card title="SDK" icon="link" href="/api-reference/sdk">
  Explore the SDK documentation
</Card>

You'll find more information in the relevant sections:

1. [Add metadata to your requests](/product/observability/metadata)
2. [Add gateway configs to your Pinecone requests](/product/ai-gateway/configs)
3. [Tracing Pinecone requests](/product/observability/traces)
4. [Setup a fallback from one reranking provider to another](/product/ai-gateway/fallbacks)
